routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\HomeController;
use App\Http\Controllers\Admin\ReporteController;

Route::get('', [HomeController::class, 'index']);
// Tramo
Route::resource('/tramo', 'App\Http\Controllers\Admin\TramoController');
// Reporte
Route::get('/reporte', ReporteController::class);
//buses
Route::resource('/bus', 'App\Http\Controllers\BusController');

// viajes
Route::resource('/viajes', 'App\Http\Controllers\ViajeController');

//asientos
Route::resource('/asientos', 'App\Http\Controllers\AsientoController');

//Route::get('/bus', [BusController::class, 'index'])->name('bus');
//espacios
Route::resource('/espacios', 'App\Http\Controllers\EspacioController');
//Route::resource('/bus/crear', [BusController::class, 'create']);

routes/web.php
<?php

use App\Http\Controllers\ViajeController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\BoletoController;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\BusController;
use App\Http\Controllers\DestinosController;
use App\Http\Controllers\PagoController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route::resource('buses','BusController');
Route::resource('buses', 'App\Http\Controllers\BusController');

Route::get('/', function () {
    return view('destinos.buscador');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/admin', function () {
    return view('admin.index');
})->name('admin');

//           ruta    clase controlador       método
Route::get('/home', [HomeController::class, 'index'])->name('home');
//           ruta    clase controlador       método
// Route::get('admin/viajes', [ViajeController::class, 'index'])->name('viajes');
// Route::get('/viajes/crear', [ViajeController::class, 'create']);
Route::get('admin/bus', [BusController::class, 'index'])->name('bus');
Route::get('/bus/crear', [BusController::class, 'create']);
Route::get('admin/viajes', [ViajeController::class, 'index'])->name('viajes');
// Route::get('/viajes', [ViajeController::class, 'index']);
Route::get('/viajes/crear', [ViajeController::class, 'create']);

Route::get('admin/bus', [BusController::class, 'index'])->name('bus');
Route::get('/bus/crear', [BusController::class, 'create']);
// Route::get('/bus', [BusController::class, 'index'])->name('home');
Route::get('boleto/{id}', BoletoController::class);
Route::get('/cliente', function(){ return view('cliente'); });
Route::resource('/compra', 'App\Http\Controllers\CompraController');
Route::get('pago/{id}', PagoController::class);
Route::get('/paypal/pay', [PaymentController::class, 'payWithPayPal']);
Route::get('/paypal/status', [PaymentController::class, 'payPalStatus']);

// Route::get('/destinos', function(){ return view('destinos.listar'); });
Route::get('/destinos',[DestinosController::class, 'index']);


//Auth::routes();


//Route::get('/buses','BusController@listar')->name('bus');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Http/Controllers/CompraController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Cliente;
use App\Models\Boleto;
use App\Models\Venta;
use App\Models\Asiento;
use App\Models\Espacio;



class CompraController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */

    // Operaciones para guardar la compra
    public function store(Request $request)
    {
        //hidden
        $id_espacio = $request->get('espacio');
        $id_venta = $request->get('venta');
        $agregar = $request->get('agregar');

        // Cliente
        $cliente = new Cliente();
        $cliente->nombre = $request->get('nombre');
        $cliente->apellido = $request->get('apellido');
        $cliente->ci = $request->get('ci');
        $cliente->telefono = $request->get('telefono');
        $cliente->save();

        // Boleto
        $boleto = new Boleto();
        $boleto->cliente_id = $cliente->id;
        $boleto->espacio_id = $id_espacio;
        $boleto->venta_id = $id_venta;
        $boleto->save();

        // Actualización de estado
        $espacio = Espacio::find($id_espacio);
        $espacio->estado = 'ocupado';
        $espacio->save();

        // Agregar pasajeros
        if($agregar == 'true'){
             return redirect('compra/'.$id_espacio.'/edit');
        } else {
            return redirect('pago/'.$id_venta);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // Formulario de compra
    public function show($id)
    {
        $venta = new Venta();
        $venta->save();
        $espacios = Espacio::join('asientos', 'asientos.id', '=', 'espacios.asiento_id')
            ->join('buses', 'buses.id', '=', 'asientos.bus_id')
            ->where('espacios.viaje_id', $id)
            ->select('espacios.*', 'asientos.num_asiento', 'asientos.fila', 'asientos.columna', 'buses.n_filas', 'buses.n_columnas')
            ->get()
            ->sortBy('fila')->sortBy('columna');
        return view('compra.show', compact('espacios'))->with(compact('venta'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // Detalle de compra
    public function edit($id)
    {
        $espacio = Espacio::find($id);
        $viaje = $espacio->viaje_id;
        $venta = Boleto::join('espacios', 'boletos.espacio_id', 'espacios.id')
            ->join('ventas', 'boletos.venta_id', 'ventas.id')->select('ventas.*')
            ->where('boletos.espacio_id', $id)->first();

        $espacios = Espacio::join('asientos', 'asientos.id', '=', 'espacios.asiento_id')
            ->join('buses', 'buses.id', '=', 'asientos.bus_id')
            ->where('espacios.viaje_id', $viaje)
            ->select('espacios.*', 'asientos.num_asiento', 'asientos.fila', 'asientos.columna', 'buses.n_filas', 'buses.n_columnas')
            ->get()
            ->sortBy('fila')->sortBy('columna');
        return view('compra.show', compact('espacios'))->with(compact('venta'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // Eliminar registro de venta en caso de cancelar compra
    public function destroy($id)
    {
        $venta = Venta::find($id);
        $venta->delete();
        return redirect('/');
    }
}

resources/views/compra/index.blade.php
@extends('template.background')
@section('contenido2')
<div class="mi-bg container-fluid">
    <div class="row ml-5">
        <h2 class="col">Detalle</h2>
    </div>
    <form action="/boleto/{{ $detalles->first()->venta_id }}" method="GET">
        @csrf
        @foreach ($detalles as $detalle)
        <div class="row ml-5 mr-5">
            <div class="card col shadow">
                <div class="card-body row">
                   <div class="col-3">
                      <h3>Pasajero</h3>
                      <p  class="h4 text-dark"><small>{{ $detalle->nombre }} {{ $detalle->apellido }}</small></p>
                   </div>
                   <div class="col-3">
                      <h3>N° de boleto</h3>
                      <p  class="h4 text-dark"><small>{{ $detalle->id }}</small></p>
                   </div>
                   <div class="col-2">
                      <h3>Origen</h3>
                      <p  class="h4 text-dark"><small>{{ $detalle->origen }}</small></p>
                   </div>
                   <div class="col-2">
                      <h3>Destino</h3>
                      <p  class="h4 text-dark"><small>{{ $detalle->destino }}</small></p>
                   </div>
                   <div class="col-2">
                      <h3>Asiento</h3>
                      <p  class="h4 text-dark"><small>{{ $detalle->num_asiento }}</small></p>
                   </div>
                </div>
             </div>
        </div>
        @endforeach
        <div class="row ml-5 mr-5">
            <div class="card col shadow">
                <div class="card-body row">
                    <div class="offset-8 col-2">
                        <h3>Precio total</h3>
                        <p  class="h4 text-dark"><small>{{ $detalle->precio * sizeof($detalles) }}</small></p>
                    </div>
                    <input type="hidden" name="precio" value="{{ $detalle->precio * sizeof($detalles) }}">
                    <div class="col-2">
                        <button type="submit" class="btn btn-success">Pagar</button>
                    </div>
                </div>
            </div>
        </div>
    </form>
</div>
@endsection

resources/views/compra/show.blade.php
@extends('template.background')
@section('contenido2')
    <div class="mi-bg container-fluid">
        {{-- <div class="row"> --}}
            <form id="form" action="/compra" method="POST" class="row">
                @csrf
                <div class="col-4 offset-md-1">
                    <div class="card shadow">
                        <div class="card-body m-3">
                            <h1 class="card-title">Selección de asiento</h5>
                            <div class="m-4">
                                @for ($i = 1; $i <= $espacios->first()->n_filas; $i++)
                                @for ($j = 1; $j <= $espacios->first()->n_columnas; $j++)
                                    @foreach ($espacios as $espacio)
                                        @if ($espacio->fila == $i && $espacio->columna == $j)
                                            @if ($espacio->estado == 'ocupado')
                                                <button type="button" class='asiento btn btn-lg m-2' id="{{ $espacio->id }}"
                                                    disabled>{{ $espacio->num_asiento }}</button>
                                            @else
                                                <button type="button" onclick="Seleccionar({{ $espacio->id }});"
                                                    class='asiento btn btn-lg m-2'
                                                    id="{{ $espacio->id }}">{{ $espacio->num_asiento }}</button>
                                            @endif
                                        @endif
                                    @endforeach
                                @endfor
                                <br>
                            @endfor
                            </div>
                        </div>
                    </div>
                </div>
                <input type="hidden" id="espacio" name="espacio" value="">
                <input type="hidden" id="venta" name="venta" value="{{ $venta->id }}">
                <input type="hidden" id="agregar" name="agregar" value="">
                <input type="hidden" id="viaje" name="viaje" value="{{ $espacios[0]->viaje_id }}">
                <div class="col-4 offset-md-1">
                    <div class="card shadow">
                        <div class="card-body m-3">
                            <h1 class="card-title">Detalle de pasajeros</h1>
                        <label class="h4"><small>Nombres</small></label>
                        <input id="nombre" name="nombre" class="form-control" type="text" placeholder="Nombre" /><br>
                        <label class="h4"><small>Apellidos</small></label>
                        <input id="apellido" name="apellido" class="form-control" type="text" placeholder="Apellidos" /><br>
                        <label class="h4"><small>CI</small></label>
                        <input id="ci" name="ci" class="form-control" type="text" placeholder="CI" /><br>
                        <label class="h4"><small>Teléfono</small></label>
                        <input id="telefono" name="telefono" class="form-control" type="text" placeholder="Teléfono" /><br>
                        <div class=''>
                            <button type="submit" onclick="Agregar()" class="btn btn-primary shadow ml-3">Añadir pasajero</button>
                            <button type="submit" class='btn btn-success shadow ml-3'>Guardar</button>
                        </div>
                        </div>
                    </div>
                </div>
            </form>
        {{-- </div> --}}
        <div class="row">
            <form action="{{ route('compra.destroy', $venta->id) }}" method="POST" class="offset-10 col-1">
                @csrf
                @method('DELETE')
                <button type="submit" class="btn btn-danger shadow">Cancelar</button>
            </form>
        </div>
    </div>
    <script>
        function Seleccionar(idEspacio) {
            console.log(idEspacio);
            var color = document.getElementById(idEspacio).style.backgroundColor;
            var id = document.getElementById('espacio').value;
            console.log(id);
            if (id && id != idEspacio) {
                alert("Ya ha seleccionado un asiento");
            } else {
                if (color == 'green') {
                    document.getElementById(idEspacio).style.backgroundColor = '';
                    document.getElementById('espacio').value = '';
                } else {
                    document.getElementById(idEspacio).style.backgroundColor = 'green';
                    document.getElementById('espacio').value = idEspacio;
                }
            }
        }

        function Agregar() {
            document.getElementById('agregar').value = 'true';
            //document.getElementById('form').method = 'GET';
            //document.getElementById('form').action = document.getElementById('espacio').value+'/edit';
            //document.getElementById('a').href = document.getElementById('espacio').value+'/edit';
        }

    </script>
@endsection